## odb-api 0.18.1

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 2.8.4 FATAL_ERROR )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake;${CMAKE_CURRENT_SOURCE_DIR}/ecbuild/cmake;${CMAKE_MODULE_PATH}" )
include( ecbuild_bundle )

project( odb_api_bundle C CXX )

ecbuild_bundle_initialize()
ecbuild_bundle( PROJECT ecbuild        STASH "ecsdk/ecbuild"      TAG 2.9.4 )
ecbuild_bundle( PROJECT eckit          STASH "ecsdk/eckit"        TAG 0.24.0 )
ecbuild_bundle( PROJECT metkit         STASH "ecsdk/metkit"       TAG 0.16.0 )
ecbuild_bundle( PROJECT odb_api        STASH "odb/odb_api"        TAG 0.18.1 )

if( ENABLE_ODB )
ecbuild_bundle( PROJECT odb            STASH "odb/odb"            TAG 1.0.10 )
ecbuild_bundle( PROJECT odb-tools      STASH "odb/odb-tools"      TAG 0.18.0 )
endif()

ecbuild_bundle_finalize()

=== ecbuild/CMakeLists.txt ===
# (C) Copyright 2011- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

############################################################################################
# cmake options:
#
#       -DCMAKE_INSTALL_PREFIX=/path/to/install

cmake_minimum_required( VERSION 2.8.4 FATAL_ERROR )

project( ecbuild C )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} )

include( ecbuild_system )

###############################################################################
# local project

ecbuild_declare_project()

configure_file( cmake/ecbuild_version.h.in ${CMAKE_BINARY_DIR}/ecbuild_version.h  )

ecbuild_add_option( FEATURE INSTALL
                    DEFAULT OFF
                    DESCRIPTION "Wether to install ecbuild files" )
# contents

ecbuild_add_resources(  TARGET ${PROJECT_NAME}_description_files
                        SOURCES_PACK
                            INSTALL
                            AUTHORS
                            NOTICE
                            LICENSE
                            COPYING
)

add_subdirectory( bin )
add_subdirectory( share )
add_subdirectory( cmake )
add_subdirectory( doc )

install( DIRECTORY cmake DESTINATION ${INSTALL_DATA_DIR} PATTERN "CMakeLists.txt" EXCLUDE )

############################################################################################
# finalize

ecbuild_install_project( NAME ${PROJECT_NAME} )

ecbuild_print_summary()

=== eckit/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.1 FATAL_ERROR )

project( eckit CXX )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 2.9 )

set( PERSISTENT_NAMESPACE "eckit" CACHE INTERNAL "" ) # needed for generating .b files for persistent support

ecbuild_declare_project()

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

### dependencies and options

ecbuild_add_option( FEATURE EXPERIMENTAL
                    DEFAULT OFF
                    DESCRIPTION "Experimental features Armadillo, CUDA, MKL, ViennaCL (not used in production)" )

### eckit::mpi

ecbuild_add_option( FEATURE MPI
                    DEFAULT ON
                    DESCRIPTION "Use system MPI libraries"
                    REQUIRED_PACKAGES "MPI COMPONENTS C" )

### eckit::cmd

ecbuild_add_option( FEATURE ECKIT_CMD
                    DEFAULT ON
                    DESCRIPTION "Utilities for administration tools"
                    REQUIRED_PACKAGES "LEXYACC" "Curses" )

### Eigen

ecbuild_add_option( FEATURE EIGEN
                    DESCRIPTION "Eigen linear algebra library"
                    REQUIRED_PACKAGES Eigen3 )

set_package_properties( Eigen3 PROPERTIES
                        DESCRIPTION "C++ template library for linear algebra"
                      )

if( ENABLE_EIGEN )
    # TODO: we should add here a test that we can compile Eigen without problems
    # TODO: don't use contrib just yet -- sort out the legal stuff first
    # set( ECKIT_CONTRIB_EIGEN 1 )
endif()

### Armadillo

ecbuild_add_option( FEATURE ARMADILLO
                    CONDITION HAVE_EXPERIMENTAL
                    DESCRIPTION "Armadillo linear algebra library"
                    REQUIRED_PACKAGES Armadillo )

set_package_properties( Armadillo PROPERTIES
                        DESCRIPTION "C++ linear algebra"
                      )

### MKL

ecbuild_add_option( FEATURE MKL
                    DESCRIPTION "MKL linear algebra library"
                    REQUIRED_PACKAGES MKL )

### LAPACK

if( ECKIT_HAVE_MKL )
    set( ECKIT_HAVE_LAPACK 1 )
    set( LAPACK_LIBRARIES ${MKL_LIBRARIES} )
else()
    ecbuild_add_option( FEATURE LAPACK
                        DESCRIPTION "Linear Algebra PACKage"
                        REQUIRED_PACKAGES "LAPACK QUIET" )
endif()

### OpenSSL (for SHA1)

ecbuild_add_option( FEATURE SSL
                    DESCRIPTION "OpenSSL support"
                    REQUIRED_PACKAGES OpenSSL )

ecbuild_info("OpenSSL ${OPENSSL_FOUND} ${OPENSSL_VERSION} : libs ${OPENSSL_LIBRARIES} incs ${OPENSSL_INCLUDE_DIR}")

### xxHash

ecbuild_add_option( FEATURE XXHASH
                    DESCRIPTION "Use xxHash for non-crypto hashing in data integrity checks"
                    REQUIRED_PACKAGES "xxHash QUIET" )

ecbuild_info("xxHash ${XXHASH_FOUND}  : libs ${XXHASH_LIBRARIES} incs ${XXHASH_INCLUDE_DIRS}")

#### Curl

ecbuild_add_option( FEATURE CURL
                    DESCRIPTION "Curl library for transfering data with URLs"
                    REQUIRED_PACKAGES CURL )

#### Jemalloc

ecbuild_add_option( FEATURE JEMALLOC
                    DEFAULT OFF
                    DESCRIPTION "Link against jemalloc memory allocator"
                    REQUIRED_PACKAGES Jemalloc )

#### CUDA

ecbuild_add_option( FEATURE CUDA
                    CONDITION HAVE_EXPERIMENTAL
                    DESCRIPTION "CUDA GPU linear algebra operations"
                    REQUIRED_PACKAGES CUDA )

### ViennaCL

ecbuild_add_option( FEATURE VIENNACL
                    CONDITION HAVE_EXPERIMENTAL
                    DESCRIPTION "ViennaCL OpenCL linear algebra operations"
                    REQUIRED_PACKAGES ViennaCL )

set_package_properties( ViennaCL PROPERTIES
                        DESCRIPTION "linear algebra library for computations on many-core architectures"
                        TYPE RECOMMENDED
                        PURPOSE "Dense and sparse matrix operations on OpenCL devices" )

### async io support

find_package( AIO )
set_package_properties( AIO PROPERTIES TYPE RECOMMENDED PURPOSE "support for asynchronous IO" )

### thread library ( preferably pthreads )

set( CMAKE_THREAD_PREFER_PTHREAD 1 )
find_package( Threads REQUIRED )

### c math library, needed when including "math.h"

find_package( CMath )

###############################################################################
# checks

# check thread library is pthreads

if( NOT ${CMAKE_USE_PTHREADS_INIT} )
    message( FATAL_ERROR "Only pthreads supported - thread library found is [${CMAKE_THREAD_LIBS_INIT}]" )
endif()

############################################################################################
# export package info

set( ECKIT_INCLUDE_DIRS   ${CMAKE_CURRENT_SOURCE_DIR}/src ${CMAKE_CURRENT_BINARY_DIR}/src )
set( ECKIT_LIBRARIES      eckit eckit_geometry eckit_linalg eckit_maths eckit_web )

if( HAVE_ECKIT_CMD)
  list( APPEND ECKIT_LIBRARIES eckit_cmd )
endif()

if( HAVE_ECKIT_MPI )
  list( APPEND ECKIT_LIBRARIES eckit_mpi )
endif()

if( HAVE_EIGEN AND ECKIT_CONTRIB_EIGEN )
  list( APPEND ECKIT_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/contrib )
endif()

if( HAVE_EXPERIMENTAL )

  list( APPEND ECKIT_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/src/experimental )

endif()

get_directory_property( ECKIT_DEFINITIONS COMPILE_DEFINITIONS )

############################################################################################
# sources

ecbuild_find_project_files()

include_directories( ${ECKIT_INCLUDE_DIRS} )
if( HAVE_EIGEN )
    include_directories( ${EIGEN3_INCLUDE_DIR} )
endif()

add_subdirectory( bamboo )
add_subdirectory( contrib )
add_subdirectory( doc )
add_subdirectory( src )
add_subdirectory( tests )
add_subdirectory( regressions )

ecbuild_add_resources( TARGET ${PROJECT_NAME}_top_files SOURCES
                       TODO AUTHORS README.md NOTICE LICENSE INSTALL ChangeLog COPYING )

############################################################################################
# finalize

foreach( _lib ${ECKIT_LIBRARIES} )
  if( TARGET ${_lib} )
    ecbuild_pkgconfig( NAME ${_lib}
                       DESCRIPTION "ECMWF C++ Toolkit - ${_lib} library"
                       URL "https://software.ecmwf.int/wiki/display/ECKIT/ecKit"
                       LIBRARIES ${_lib} )
  endif()
endforeach()

ecbuild_install_project( NAME ${PROJECT_NAME} )

ecbuild_print_summary()

=== metkit/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.1 FATAL_ERROR )

project( metkit CXX )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 2.9 )

ecbuild_declare_project()

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

### dependencies and options

ecbuild_add_option( FEATURE EXPERIMENTAL
                    DEFAULT OFF
                    DESCRIPTION "Experimental features" )
# grib support

ecbuild_add_option( FEATURE GRIB
                    DEFAULT ON
                    DESCRIPTION "Add support for GRIB format (grib_api not supported)"
                    REQUIRED_PACKAGES "PROJECT eccodes VERSION 2.5" )

# netcdf support

ecbuild_add_option( FEATURE NETCDF
  DESCRIPTION "Support for NetCDF data"
  DEFAULT ON
  REQUIRED_PACKAGES NetCDF
  NO_TPL
)

# eckit

ecbuild_use_package( PROJECT eckit  VERSION  0.21.0 REQUIRED )

### export package info

set( METKIT_INCLUDE_DIRS   ${CMAKE_CURRENT_SOURCE_DIR}/src ${CMAKE_CURRENT_BINARY_DIR}/src )
set( METKIT_LIBRARIES      metkit )

get_directory_property( METKIT_DEFINITIONS COMPILE_DEFINITIONS )

### sources

include_directories( ${METKIT_INCLUDE_DIRS} )

add_subdirectory( src )
add_subdirectory( share )

### finalize project

ecbuild_pkgconfig( NAME metkit
                   DESCRIPTION "ECMWF Meteorological toolkit"
                   LIBRARIES metkit )

ecbuild_install_project( NAME ${PROJECT_NAME} )

ecbuild_print_summary()

=== odb-tools/CMakeLists.txt ===
##
# This package exists to contain odb_api tools that make use of ODB1, to break the circular
# dependency when building with IFS.

cmake_minimum_required( VERSION 3.1 FATAL_ERROR )

project( odb_tools CXX Fortran )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 2.9 )

ecbuild_declare_project()

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

###############################################################################
# local project

ecbuild_use_package( PROJECT eckit   VERSION 0.21 REQUIRED )
ecbuild_use_package( PROJECT odb_api VERSION ${odb_tools_VERSION_STR} REQUIRED )
ecbuild_use_package( PROJECT odb     VERSION 1.0.5 REQUIRED )

###############################################################################
# some variables/options of this project

ecbuild_add_option( FEATURE MIGRATOR
                    DESCRIPTION "whether or not to build the ODB migrator tool"
                    DEFAULT ON
                    REQUIRED_PACKAGES "PROJECT odb VERSION 1.0 QUIET" )

if( HAVE_MIGRATOR )
  ecbuild_enable_fortran( REQUIRED MODULE_DIRECTORY ${CMAKE_BINARY_DIR}/module )
endif()

if(CMAKE_Fortran_COMPILER_ID STREQUAL "GNU")
  ecbuild_add_fortran_flags("-fPIC -ffree-line-length-none")
endif()

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  ecbuild_add_cxx_flags("-fPIC -Wl,--as-needed")
endif()

ecbuild_add_option( FEATURE OMP
                    DESCRIPTION "Support for OpenMP threaded parallelism"
                    REQUIRED_PACKAGES "OMP COMPONENTS CXX ${Fortran}" )

if( HAVE_OMP )
  ecbuild_enable_omp()
else()
  ecbuild_enable_ompstubs()
endif()

ecbuild_add_option( FEATURE PYTHON
                    DESCRIPTION "whether or not to build the Python interface"
                    DEFAULT OFF
                    REQUIRED_PACKAGES "Python VERSION 2.7 NO_LIBS" SWIG )

###############################################################################
# contents

set_directory_properties( PROPERTIES COMPILE_DEFINITIONS "${ECKIT_DEFINITIONS}" )

get_directory_property( ODB_API_DEFINITIONS COMPILE_DEFINITIONS )

set( ODB_TOOLS_INCLUDE_DIRS   ${CMAKE_CURRENT_SOURCE_DIR}/src ${CMAKE_CURRENT_BINARY_DIR}/src )

list( APPEND ODB_API_INCLUDE_DIRS ${CMAKE_BINARY_DIR}/module )
list( INSERT ODB_API_LIBRARIES 0 Odb_fortran )

include_directories( ${ODB_API_INCLUDE_DIRS} ${ODB_TOOLS_INCLUDE_DIRS} )

add_subdirectory( src )

############################################################################################
# finalize

ecbuild_install_project( NAME OdbTools )

ecbuild_print_summary()

=== odb/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.4 FATAL_ERROR)

project(odb C Fortran)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

if(NOT PROJECT_NAME STREQUAL CMAKE_PROJECT_NAME)
  set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake PARENT_SCOPE)
endif()

include(ecbuild_system)
include(odb_add_schema)
include(odb_link_schemas)
include(odb_set_environment)

ecbuild_requires_macro_version(1.9)

if(PROJECT_NAME STREQUAL CMAKE_PROJECT_NAME)
  set(CMAKE_Fortran_MODULE_DIRECTORY ${CMAKE_BINARY_DIR}/module)
else()
  set(CMAKE_Fortran_MODULE_DIRECTORY ${CMAKE_BINARY_DIR}/odb/module)
endif()

ecbuild_declare_project()

ecbuild_add_option(FEATURE OMP
  DESCRIPTION "Support for OpenMP multi-threading"
  REQUIRED_PACKAGES "OMP COMPONENTS C"
  DEFAULT ON)

if(HAVE_OMP)
  ecbuild_enable_omp()
endif()

ecbuild_add_option(FEATURE ODB_MPI
  DESCRIPTION "Use system MPI library"
  REQUIRED_PACKAGES MPI
  DEFAULT OFF)

ecbuild_add_option(FEATURE ODB_EMOS
  DESCRIPTION "Use system EMOS library"
  REQUIRED_PACKAGES libemos
  DEFAULT OFF)

ecbuild_add_option(FEATURE ODB_SHARED_LIBS
  DESCRIPTION "Build ODB project with shared libraries (overrides BUILD_SHARED_LIBS)"
  DEFAULT ${BUILD_SHARED_LIBS}
  ADVANCED)

set(BUILD_SHARED_LIBS ${ENABLE_ODB_SHARED_LIBS})

option(ODB_CLIENT_SERVER "Enable client/server support" OFF)

if(ODB_CLIENT_SERVER AND HAVE_ODB_SHARED_LIBS)
  message(FATAL_ERROR "Please set BUILD_SHARED_LIBS or ENABLE_ODB_SHARED_LIBS to OFF for client/server support")
endif()

test_big_endian(BIG_ENDIAN)

if(NOT BIG_ENDIAN)
  add_definitions(-DLITTLE)
endif()

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
  add_definitions(-DLINUX)
endif()

if(CMAKE_C_COMPILER_ID MATCHES "Intel")
    set(CMAKE_C_FLAGS "-fPIC -DINTEL -traceback")
endif()

if(CMAKE_Fortran_COMPILER_ID MATCHES "GNU")

  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
  set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fPIC -ffree-line-length-none")
  set(CMAKE_Fortran_FLAGS_DEBUG "-g -O0 -fcheck=bounds")
  set(CMAKE_Fortran_FLAGS_RELEASE "-O2")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--as-needed")

elseif(CMAKE_Fortran_COMPILER_ID MATCHES "Intel")

  set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fPIC -traceback -fpe0 -names lowercase")
  set(CMAKE_Fortran_FLAGS_DEBUG "-g -O0 -check bounds -check pointers")
  set(CMAKE_EXE_LINKER_FLAGS "-Wl,--as-needed")

elseif(CMAKE_Fortran_COMPILER_ID MATCHES "PGI")

  set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fPIC -Ktrap=fp -noswitcherror")
  set(CMAKE_Fortran_FLAGS_DEBUG "-g -O0 -Mbounds")
  set(CMAKE_Fortran_FLAGS_RELEASE "-O2")

elseif(CMAKE_Fortran_COMPILER_ID MATCHES "Cray")

  set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -hPIC -emf -M 226,867,7212")
  set(CMAKE_Fortran_FLAGS_DEBUG "-G0 -O0 -hdevelop")
  set(CMAKE_Fortran_FLAGS_RELEASE "-G2 -O2")
  set(CMAKE_C_FLAGS "-fPIC -hnomessage=186:192:223:236:7212:10082")
  set(CMAKE_EXE_LINKER_FLAGS "-Wl,--as-needed")

endif()

find_package(Dl REQUIRED)
find_package(PythonInterp REQUIRED)

find_program(ODB_AR NAMES sxar ar)
find_program(ODB_GZIP NAMES gzip)
find_program(ODB_GUNZIP NAMES gunzip)

file(GLOB schema_dirs RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/src "src/ddl.[A-Z0-9]*")
string(REGEX REPLACE "ddl.([A-Z0-9]*)" "\\1" schemas "${schema_dirs}")
set(ODB_SCHEMAS ${schemas} CACHE STRING "List of pre-compiled ODB schemas")

foreach(schema ${ODB_SCHEMAS})
  set(ODB_HAVE_${schema} 1 CACHE INTERNAL "")
endforeach()

get_directory_property(ODB_DEFINITIONS COMPILE_DEFINITIONS)

list(APPEND ODB_TPLS Dl)

set(ODB_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/src/include ${CMAKE_Fortran_MODULE_DIRECTORY})
set(ODB_LIBRARIES odb_lib)
set(ODB_CMAKE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/cmake CACHE INTERNAL "")

odb_set_environment(ODB_ENVIRONMENT ROOT ${CMAKE_BINARY_DIR})
odb_set_environment(ODB_INSTALL_ENVIRONMENT ROOT ${CMAKE_INSTALL_PREFIX})

ecbuild_find_project_files()

add_subdirectory(cmake)
add_subdirectory(src)
add_subdirectory(share)
add_subdirectory(tests)

odb_set_environment(ODB_PKGCONFIG_ENVIRONMENT ROOT \\\${prefix})

set(_odb_pkgconfig_vars)

foreach(_pair ${ODB_PKGCONFIG_ENVIRONMENT})
    string(REGEX MATCH "^[^=]+" _name ${_pair})
    string(REGEX REPLACE "${_name}=" "" _value ${_pair})
    list(APPEND _odb_pkgconfig_vars ${_name})
    set(${_name} ${_value})
endforeach()

ecbuild_pkgconfig(URL "https://software.ecmwf.int/wiki/display/ODB"
  DESCRIPTION "Observation database software"
  VARIABLES ${_odb_pkgconfig_vars})

ecbuild_install_project(NAME odb)

ecbuild_print_summary()

=== odb_api/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.1 FATAL_ERROR )

project( odb_api C CXX )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 2.9 )

ecbuild_declare_project()

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

########################################################################################################################
### dependencies and options

ecbuild_use_package( PROJECT eckit  VERSION 0.21 REQUIRED )
ecbuild_use_package( PROJECT metkit VERSION 0.11 REQUIRED )

ecbuild_add_resources( TARGET ${PROJECT_NAME}_no_odb DONT_PACK_REGEX "*.odb" )
ecbuild_add_resources( TARGET ${PROJECT_NAME}_no_oda DONT_PACK_REGEX "*.oda" )

ecbuild_dont_pack(REGEX "*.odb")
ecbuild_dont_pack(REGEX ".gdbinit")

###############################################################################
# some variables/options of this project

ecbuild_add_option( FEATURE FORTRAN
                    DESCRIPTION "whether or not to build the Fortran interface"
                    DEFAULT OFF )

#ecbuild_add_option( FEATURE NETCDF
#                    DESCRIPTION "whether or not to build the odb2netcdf tool"
#                    DEFAULT OFF
#                    REQUIRED_PACKAGES "NetCDF COMPONENTS CXX" )

ecbuild_add_option( FEATURE ODB_API_SERVER_SIDE
                    DESCRIPTION "Support for keyword SERVER_SIDE"
                    DEFAULT OFF )

ecbuild_add_option( FEATURE ODB_SERVER_TIME_FORMAT_FOUR_DIGITS
                    DESCRIPTION "ODB Server uses four digits format of time"
                    DEFAULT OFF )


SET(ODB_API_SCHEMA_PATH "" CACHE STRING "Path to schema file that will be loaded before executing SQL")

if( HAVE_FORTRAN )

    set( Fortran Fortran )
    ecbuild_enable_fortran( REQUIRED MODULE_DIRECTORY ${CMAKE_BINARY_DIR}/module )

endif()


ecbuild_add_option( FEATURE OMP
                    DESCRIPTION "Support for OpenMP threaded parallelism"
                    REQUIRED_PACKAGES "OMP COMPONENTS CXX ${Fortran}" )

if( HAVE_OMP )
  ecbuild_enable_omp()
else()
  ecbuild_enable_ompstubs()
endif()

ecbuild_add_option( FEATURE PYTHON
                    DESCRIPTION "whether or not to build the Python interface"
                    DEFAULT OFF
                    REQUIRED_PACKAGES "Python VERSION 2.7" SWIG )

###############################################################################
# contents

set_directory_properties( PROPERTIES COMPILE_DEFINITIONS "${ECKIT_DEFINITIONS}" )

get_directory_property( ODB_API_DEFINITIONS COMPILE_DEFINITIONS )

set( ODB_API_INCLUDE_DIRS   ${CMAKE_CURRENT_SOURCE_DIR}/src ${CMAKE_CURRENT_BINARY_DIR}/src )
set( ODB_API_LIBRARIES      Odb )

if( HAVE_FORTRAN )
  list( APPEND ODB_API_INCLUDE_DIRS ${CMAKE_BINARY_DIR}/module )
  list( INSERT ODB_API_LIBRARIES 0 Odb_fortran )
endif()

add_subdirectory( src )
add_subdirectory( regressions )
add_subdirectory( tests )

############################################################################################
# finalize

ecbuild_pkgconfig( NAME ${PROJECT_NAME}
                   DESCRIPTION "ECMWF coding, decoding and processing of observational data"
                   URL "https://software.ecmwf.int/wiki/display/ODB/ODB+API"
                   LIBRARIES Odb )

ecbuild_install_project( NAME OdbAPI )

ecbuild_print_summary()

=== ecbuild/doc/CMakeLists.txt ===
# (C) Copyright 2011- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

find_package( PythonInterp )

if( PYTHONINTERP_FOUND )

  file( GLOB ECBUILD_MODULE RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
        ${CMAKE_SOURCE_DIR}/cmake/ecbuild_*.cmake )

  add_custom_target( upload_docs COMMENT "Uploading documentation" )
  add_custom_command( TARGET upload_docs POST_BUILD
                      COMMAND ${PYTHON_EXECUTABLE} upload.py --logfile "${CMAKE_CURRENT_BINARY_DIR}/upload.log" ${ECBUILD_MODULE}
                      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                      COMMENT "Uploading documentation" )

endif()

=== ecbuild/share/CMakeLists.txt ===
# (C) Copyright 2011- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

# ecbuild_add_resources( TARGET ecbuild_share
#	SOURCE_PACK ecmwf_license_header.txt
#	DONT_PACK_DIRS ecbuild )

install( DIRECTORY ecbuild/toolchains USE_SOURCE_PERMISSIONS DESTINATION ${INSTALL_DATA_DIR} )

=== eckit/contrib/CMakeLists.txt ===
### Eigen

if( HAVE_EIGEN AND ECKIT_CONTRIB_EIGEN )

	install( DIRECTORY eigen3 DESTINATION ${INSTALL_INCLUDE_DIR} )

	### pack all contrib directory

	file( GLOB_RECURSE contrib_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "*" )

	ecbuild_add_resources(  TARGET ${PROJECT_NAME}_contribs
							SOURCES_PACK ${contrib_files} )
endif()

=== eckit/regressions/CMakeLists.txt ===
list( APPEND regressions ECKIT-175 ECKIT-221 ECKIT-166 )
message("MPIEXEC = ${MPIEXEC}")
foreach( r ${regressions} )

  configure_file( ${r}.sh.in ${r}.sh @ONLY )

  ecbuild_add_executable(
    NOINSTALL
    TARGET   ${r}.x
    SOURCES  ${r}.cc
    LIBS     eckit_mpi eckit )

  ecbuild_add_test(
    TYPE     SCRIPT
    COMMAND  ${r}.sh )

endforeach()

=== eckit/src/CMakeLists.txt ===
# (C) Copyright 1996- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

### sources

add_subdirectory( eckit  )

if( HAVE_EXPERIMENTAL )
  add_subdirectory( experimental )
endif()

add_subdirectory( apps )

=== debian/changelog ===
odb-api (0.18.1-10build1) focal; urgency=medium

  * No-change rebuild to drop python3.7.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 18 Feb 2020 09:21:04 +0100

odb-api (0.18.1-10) unstable; urgency=medium

  * Add version number to B-D on eckit to ensure we pull recent version
  * Second definition of -D_ABI64=3 needed for MIPS fix in mips64.patch

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 24 Oct 2019 16:00:06 +0100

odb-api (0.18.1-9) unstable; urgency=medium

  * Build python3.8 properly. Closes: #942757
  * Better fix for MIPS64 FTBFS, thanks to YunQuiang Su. Closes: #924571

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 22 Oct 2019 13:40:54 +0100

odb-api (0.18.1-8) unstable; urgency=medium

  * Drop Fortran-Mod: no longer used by dh_fortran_mod
  * Standards-Version: 4.4.1.0; no changes required
  * Patch for eckit 1.4.2 changes (+ compiler update?)
  * Split eckit; now provided in separate package
  * Typo in d/rules blocks python3.8 build. Closes: #942757, 3942687

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 22 Oct 2019 10:09:57 +0100

odb-api (0.18.1-7) unstable; urgency=medium

  * Add libopenmpi-dev runtime dependency, to help cmake find libeckit_mpi include
    directories. Closes: #936049

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 01 Sep 2019 17:48:13 +0100

odb-api (0.18.1-6) unstable; urgency=medium

  * Parch to include std includes in headers needed for metview compilation
  * Change odb-api-bin depend on -dev pkg to a recommends. Closes: #925266
  * Build-Depend on gfortran | fortran-compiler for flang
  * Use debhelper-compat (= 12)
  * Standards-Version: 4.4.0

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 09 Aug 2019 15:00:31 +0100

odb-api (0.18.1-5) unstable; urgency=medium

  * Fix broken symlinks. Closes: #924162

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 10 Mar 2019 09:18:57 +0000

odb-api (0.18.1-4) unstable; urgency=medium

  * Typo in d/control depencencies. Closes: #918738

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 09 Jan 2019 21:35:34 +0000

odb-api (0.18.1-3) unstable; urgency=medium

  * More sanitization of cmake scripts for reproducibility.
  * Don't ship odb_api-targets.cmake or  odb-targets.cmake in -dev package
    as the targets are mixed in -dev and -bin; magics++/metview build ok
    without them. Closes: #918554
  * Build with dh-fortran-mod >= 0.11 

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 08 Jan 2019 06:27:57 +0000

odb-api (0.18.1-2) unstable; urgency=medium

  * Add Conflicts: to libodb-api-dev on libodb-dev. (Unrelated, but both ship
    libodb.so). Closes: #917988.

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 03 Jan 2019 12:12:28 +0000

odb-api (0.18.1-1) unstable; urgency=medium

  * New upstream release
  * Build-Depend on fcm
  * Use dh-fortran-mod > 0.7, with ${Fortran-Mod}
  * Sanitize cmake scripts for reproducible builds (remove build paths)
  * No longer ship syslog-* binaries
  * More shared libs; add debian 0d versioning
  * Drop M-A: same for python3 package
  * Move all .so packages to -dev pkg; make -bin pkg depend on -dev
  * Standards-Version: 4.3.0

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 01 Jan 2019 12:25:12 +0000

odb-api (0.18.0-7) unstable; urgency=medium

  * Drop hard-coded xz compression
  * Rebuild against libeccodes without memfs
  * Add BLAS to Build-Depends 
  * Change gfortran-8 -> gfortran
  * Delete accidental python2.7* stuff in py3 package

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 22 Nov 2018 08:53:10 +0000

odb-api (0.18.0-6) unstable; urgency=medium

  * Standards-Version: 4.2.1
  * Undo hard-coded gfortran-8 now transition complete
  * Delete obsolete symlinks. Closes: #909616

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 27 Sep 2018 12:25:08 +0100

=== debian/control ===
Source: odb-api
Section: utils
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (=12),
 dh-python,
 dh-fortran-mod (>= 0.11),
 gfortran | fortran-compiler, 
 fcm,
 bison,
 flex,
 ecbuild,
 libeckit-dev (>= 1.4.2),
 liblz4-dev,
 libbz2-dev,
 libxxhash-dev,
 libsnappy-dev,
 libopenjp2-7-dev,
 libboost-dev (>= 1.47.0), libboost-test-dev, 
 libssl-dev,
 libemos-dev,
 libncurses5-dev,
 libnetcdf-cxx-legacy-dev,
 libeccodes-tools,
 chrpath,
 doxygen,
 swig,
 libeccodes-dev (>= 2.5.0),
 mpi-default-dev,
 python3-all-dev,
 libnetcdf-dev,
 libc6-dev-mips32 [mips64el]
Standards-Version: 4.4.1.0
Homepage: https://software.ecmwf.int/wiki/display/ODBAPI
Vcs-Browser: https://salsa.debian.org:/science-team/odb-api.git
Vcs-Git: https://salsa.debian.org:/science-team/odb-api.git

Package: libodb-api-0d
Section: libs
Architecture: any
Multi-Arch: same
Breaks: libodb-api-dev (<< 0.18.1-1)
Depends: ${misc:Depends}, ${shlibs:Depends}, libodb-api-data
Description: Observational Data processing API for meteorology
 ODB API is a software developed at ECMWF for encoding and processing of
 observational data. It includes a SQL filtering and statistics engine, 
 command line tools and APIs for C/C++, Fortran and Python.
 .
 ODB API works with data formats used in the ECMWF observational feedback
 archive.  Development of ODB API has been partially funded by the 
 UK Met Office.

Package: libodb-api-bin
Section: libs
Architecture: any
Multi-Arch: foreign
Depends: libodb-api-0d ( = ${binary:Version}), 
  ${shlibs:Depends}, ${misc:Depends}, ksh | mksh | pdksh | zsh
Recommends: libodb-api-dev (= ${binary:Version})
Description: Tools for the Observational Data Processing (ODB) API
 ODB API is a software developed at ECMWF for encoding and processing of
 observational data. It includes a SQL filtering and statistics engine, 
 command line tools and APIs for C/C++, Fortran and Python.
 .
 This package provides tools for ODB handling.

Package: libodb-api-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Data used by ECMWF Observational Data Processing (ODB) 
 ODB API is a software developed at ECMWF for encoding and processing of
 observational data. 
 .
 This package contains data used by ODB tools.
 
Package: libodb-api-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libodb-api-0d (= ${binary:Version}), libodb-api-bin (= ${binary:Version}), 
  ${misc:Depends}, libopenmpi-dev, libeckit-dev
Breaks: libodb-api-0d (<< 0.18.1-1)
Replaces: libodb-api-0d (<< 0.18.1-1)
Conflicts: libodb-dev
Recommends: libodb-api-bin, pkg-config, fortran-compiler
Description: Observational Data processing API for meteorology
 ODB API is a software developed at ECMWF for encoding and processing of
 observational data. It includes a SQL filtering and statistics engine, 
 command line tools and APIs for C/C++, Fortran and Python.
 .
 This package provides shared libraries and headers.

Package: python3-odb-api
Section: python
Architecture: any
Depends: libodb-api-0d ( = ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}
Description: Python Observational Data processing API for meteorology
 ODB API is a software developed at ECMWF for encoding and processing of
 observational data. It includes a SQL filtering and statistics engine, 
 command line tools and APIs for C/C++, Fortran and Python.
 .
 This package provides the Python wrappers to the ODB API.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
ARCH:=$(shell dpkg --print-architecture)
AUTOGENERATED:= libodb-api-0d.install libodb-api-dev.install libodb-api-dev.links
LIBDIR:=/usr/lib/${DEB_HOST_MULTIARCH}
DESTDIR:=$(CURDIR)/debian/tmp
BUILDDIR:=$(CURDIR)/debian/build

# Add MPI flags
CFLAGS:= $(dpkg --buildflags CFLAGS) $(shell pkg-config mpi --cflags)
CXXFLAGS:= $(dpkg --buildflags CXXFLAGS) $(shell pkg-config mpi-cxx --cflags)
LDFLAGS:= $(dpkg --buildflags LDFLAGS) $(shell pkg-config mpi-cxx --libs)
export CFLAGS CXXFLAGS LDFLAGS

# The magic debhelper  rule
%:
	dh $@ --buildsystem=cmake --with=python3,fortran_mod --builddirectory=$(BUILDDIR)

ifeq ($(ARCH), hurd-i386)
  AIO:= -DENABLE_AIO=OFF
endif

# For MPI tests
export OMPI_MCA_rmaps_base_oversubscribe=1

PY3DEFAULT:=$(shell py3versions --default)
PY3OTHERS:=`py3versions --supported | sed -e 's%${PY3DEFAULT}%%'  `

CMAKE_DIR:=debian/tmp/usr/share
INC_DIR:=debian/tmp/usr/include

CMAKE_CFLAGS:= -DDISABLE_AIO=ON \
		-DCMAKE_BUILD_TYPE=Release \
		-DDISABLE_OS_CHECK=ON \
		-DBUILD_SHARED_LIBS=ON \
		-DENABLE_EIGEN=ON \
		-DENABLE_NETCDF=ON \
		-DENABLE_FORTRAN=ON \
		-DENABLE_PYTHON=ON \
		-DENABLE_OMP=ON \
		-DENABLE_ODB=ON \
		-DENABLE_ODB_MPI=ON \
		-DENABLE_ODB_API_SERVER_SIDE=ON 

override_dh_auto_clean:
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})
	dh_auto_clean

override_dh_auto_configure:
	for f in ${AUTOGENERATED} ; do \
		sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g' < debian/$$f.in  > debian/$$f ; \
	done
	dh_auto_configure --builddirectory=$(BUILDDIR) --  \
		${CMAKE_CFLAGS} -DPYTHON_EXECUTABLE=/usr/bin/${PY3DEFAULT} 
	for f in ${PY3OTHERS} ; do \
		dh_auto_configure --builddirectory=$(BUILDDIR)/$$f -- \
			 ${CMAKE_CFLAGS} -DPYTHON_EXECUTABLE=/usr/bin/$$f ; \
		done

override_dh_auto_build:
	dh_auto_build --builddirectory=$(BUILDDIR)
	for f in ${PY3OTHERS} ; do \
		dh_auto_build --builddirectory=$(BUILDDIR)/$$f ; \
		done

override_dh_auto_test:
	@echo "Skipping tests; need to disable downloads"
	dh_auto_test ||  echo "Ignoring test failures" 

override_dh_auto_install:
	dh_auto_install	
	mv debian/tmp/usr/lib/python2.7 debian/tmp/usr/lib/$(PY3DEFAULT)
	for f in ${PY3OTHERS} ; do \
		$(MAKE) -C $(BUILDDIR)/$$f install DESTDIR=$(DESTDIR)  ; \
		mv debian/tmp/usr/lib/python2.7 debian/tmp/usr/lib/$$f ; \
		done
	for d in debian/tmp/usr/bin/* ; do \
		( chrpath -d $$d || echo "Ignoring non-ELF file errors") ; done
	chrpath -d debian/tmp/usr/lib/*.so*
	# Fix broken paths
	for d in \
	         ${CMAKE_DIR}/odb/cmake/odb-targets.cmake \
	         ${CMAKE_DIR}/odb/cmake/odb-targets-release.cmake  \
		 ${CMAKE_DIR}/odb/cmake/odb-import.cmake \
		 ${CMAKE_DIR}/odb_api/cmake/odb_api-targets-release.cmake ; do \
	cat $$d | \
		sed -e 's%$${_IMPORT_PREFIX}/bin%/usr/bin%' | \
		sed -e 's%"/usr/bin/odb"%"/usr/bin/ecmwf_odb"%' | \
		sed -e 's%"/usr/bin/qtar"%"/usr/bin/ecmwf_qtar"%' | \
		sed -e 's%"=/bin/gzip"%"=/usr/bin/gzip"%' | \
		sed -e 's%"=/bin/gunzip"%"=/usr/bin/gunzip"%' | \
		sed -e 	's%$${_IMPORT_PREFIX}/lib%$(LIBDIR)%' > ${CMAKE_DIR}/tmp ; \
		mv ${CMAKE_DIR}/tmp $$d ; done
	# Sanitise paths for bit reproducibility
	for d in ${CMAKE_DIR}/odb_api/cmake/odb_api-config.cmake \
	 	 ${CMAKE_DIR}/metkit/cmake/metkit-config.cmake \
		 ${CMAKE_DIR}/odb/cmake/odb-import.cmake \
		 ${CMAKE_DIR}/odb_api_bundle/cmake/odb_api_bundle-config.cmake \
		 ${CMAKE_DIR}/odb_tools/cmake/odb_tools-config.cmake \
		 ${CMAKE_DIR}/odb/cmake//odb-config.cmake ; do \
			cat $$d | sed -e 's%${CURDIR}%/build/odb-api%g' > ${CMAKE_DIR}/tmp ; \
			mv ${CMAKE_DIR}/tmp $$d; \
			done
	for d in ${DESTDIR}/usr/lib/pkgconfig/odb.pc ; do \
		cat $$d | \
	                sed -e 's%"=/bin/gzip"%"=/usr/bin/gzip"%' | \
	                sed -e 's%"=/bin/gunzip"%"=/usr/bin/gunzip"%' | \
			sed -e 's%${CURDIR}%/build/odb-api%g' > ${DESTDIR}/tmpf ; \
			mv ${DESTDIR}/tmpf $$d; \
			done
	# Delete files that break reproducibility, and refs from include files
	rm -f ${INC_DIR}/odb_api/odb_api_ecbuild_config.h \
		${INC_DIR}/metkit/metkit_ecbuild_config.h
	grep -v BUILD_DIR ${INC_DIR}/ecml/ecml_config.h > ${INC_DIR}/tmp
	mv ${INC_DIR}/tmp ${INC_DIR}/ecml/ecml_config.h
	grep -v odb_api_ecbuild_config.h ${INC_DIR}/odb_api/odb_api_config.h | \
		grep -v ODB_API_BINARY_DIR > ${INC_DIR}/tmp
	mv ${INC_DIR}/tmp ${INC_DIR}/odb_api/odb_api_config.h
	grep -v metkit_ecbuild_config.h ${INC_DIR}/metkit/metkit_config.h > ${INC_DIR}/tmp
	mv ${INC_DIR}/tmp ${INC_DIR}/metkit/metkit_config.h
	# Avoid conflict with different odb ( #880890) 
	mv debian/tmp/usr/bin/odb	debian/tmp/usr/bin/ecmwf_odb
	# #903445: qtar conflicts with hxtools
	mv debian/tmp/usr/bin/qtar	debian/tmp/usr/bin/ecmwf_qtar
	# Garbage
	rm -rf debian/tmp/usr/lib/python3.*/python2.7

=== debian/watch ===
version=3
https://confluence.ecmwf.int/display/ODBAPI/Releases /download/attachments/61117379/odb_api_bundle\-(.+)\-Source\.tar\.gz\?api=v2
